using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;

namespace Tracker.Data.DataTransfer
{
	/// <summary>
	/// Object data transfer definition for the 'Log' table
	/// </summary>
	[Serializable]
	[DataContract]
	public partial class Log : Tracker.Data.EFDAL.Interfaces.Entity.ILog, Tracker.Data.EFDAL.Interfaces.IDTO
	{
		#region Constructors

		/// <summary>
		/// The default contructor for the Log DTO
		/// </summary>
		public Log()
		{
		}

		#endregion

		#region Object Properties

		/// <summary>
		/// The Description field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("Description")]
		public virtual string Description { get; set; }

		/// <summary>
		/// The Hours field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("Hours")]
		public virtual decimal? Hours { get; set; }

		/// <summary>
		/// The ID field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("ID")]
		[System.ComponentModel.DataAnnotations.Key()]
		[System.ComponentModel.ReadOnly(true)]
		public virtual int ID { get; set; }

		/// <summary>
		/// The Note field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("Note")]
		public virtual string Note { get; set; }

		/// <summary>
		/// The StatusId field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("StatusId")]
		public virtual int? StatusId { get; set; }

		/// <summary>
		/// The TaskId field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("TaskId")]
		public virtual int? TaskId { get; set; }

		/// <summary>
		/// The UpdateTime field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("UpdateTime")]
		public virtual DateTime? UpdateTime { get; set; }

		/// <summary>
		/// The CreatedDate field
		/// </summary>
		[DataMember]
		public virtual DateTime? CreatedDate { get; set; }

		/// <summary>
		/// The CreatedBy field
		/// </summary>
		[DataMember]
		public virtual string CreatedBy { get; set; }

		/// <summary>
		/// The ModifiedDate field
		/// </summary>
		[DataMember]
		public virtual DateTime? ModifiedDate { get; set; }

		/// <summary>
		/// The ModifiedBy field
		/// </summary>
		[DataMember]
		public virtual string ModifiedBy { get; set; }


		#endregion

		#region Navigation Properties

		/// <summary>
		/// The relation StatusDomain -> Log (Role: Status_log)
		/// </summary>
		[DataMember]
		public virtual Tracker.Data.EFDAL.Interfaces.Entity.IStatusDomain Status_logStatusDomain { get; set; }

		/// <summary>
		/// The relation Task -> Log (Role: Task_log)
		/// </summary>
		[DataMember]
		public virtual Tracker.Data.EFDAL.Interfaces.Entity.ITask Task_logTask { get; set; }

		#region Clone

		/// <summary>
		/// Creates a shallow copy of this object of all simple properties
		/// </summary>
		/// <returns></returns>
		public virtual object Clone()
		{
			var newItem = new Log();
			newItem.Description = this.Description;
			newItem.Hours = this.Hours;
			newItem.ID = this.ID;
			newItem.Note = this.Note;
			newItem.StatusId = this.StatusId;
			newItem.TaskId = this.TaskId;
			newItem.UpdateTime = this.UpdateTime;
			return newItem;
		}

		/// <summary>
		/// Creates a shallow copy of this object of all simple properties
		/// </summary>
		public static Log Clone(Tracker.Data.EFDAL.Interfaces.Entity.ILog item)
		{
			var newItem = new Log();
			newItem.Description = item.Description;
			newItem.Hours = item.Hours;
			newItem.ID = item.ID;
			newItem.Note = item.Note;
			newItem.StatusId = item.StatusId;
			newItem.TaskId = item.TaskId;
			newItem.UpdateTime = item.UpdateTime;
			return newItem;
		}

		#endregion

		#endregion

	}

}
