using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;

namespace Tracker.Data.DataTransfer
{
	/// <summary>
	/// Object data transfer definition for the 'StatusDomain' table
	/// </summary>
	[Serializable]
	[DataContract]
	public partial class StatusDomain : Tracker.Data.EFDAL.Interfaces.Entity.IStatusDomain, Tracker.Data.EFDAL.Interfaces.IDTO
	{
		#region Constructors

		/// <summary>
		/// The default contructor for the StatusDomain DTO
		/// </summary>
		public StatusDomain()
		{
		}

		#endregion

		#region Object Properties

		/// <summary>
		/// The ID field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("ID")]
		[System.ComponentModel.DataAnnotations.Key()]
		[System.ComponentModel.ReadOnly(true)]
		public virtual int ID { get; set; }

		/// <summary>
		/// The Status field
		/// </summary>
		[DataMember]
		[System.ComponentModel.DisplayName("Status")]
		public virtual string Status { get; set; }

		/// <summary>
		/// The CreatedDate field
		/// </summary>
		[DataMember]
		public virtual DateTime? CreatedDate { get; set; }

		/// <summary>
		/// The CreatedBy field
		/// </summary>
		[DataMember]
		public virtual string CreatedBy { get; set; }

		/// <summary>
		/// The ModifiedDate field
		/// </summary>
		[DataMember]
		public virtual DateTime? ModifiedDate { get; set; }

		/// <summary>
		/// The ModifiedBy field
		/// </summary>
		[DataMember]
		public virtual string ModifiedBy { get; set; }


		#endregion

		#region Navigation Properties

		/// <summary>
		/// The relation StatusDomain -> Log (Role: Status_log)
		/// </summary>
		[DataMember]
		public virtual ICollection<Tracker.Data.EFDAL.Interfaces.Entity.ILog> Status_logLogList { get; set; }

		/// <summary>
		/// The relation StatusDomain -> Task (Role: Status_task)
		/// </summary>
		[DataMember]
		public virtual ICollection<Tracker.Data.EFDAL.Interfaces.Entity.ITask> Status_taskTaskList { get; set; }

		#region Clone

		/// <summary>
		/// Creates a shallow copy of this object of all simple properties
		/// </summary>
		/// <returns></returns>
		public virtual object Clone()
		{
			var newItem = new StatusDomain();
			newItem.ID = this.ID;
			newItem.Status = this.Status;
			return newItem;
		}

		/// <summary>
		/// Creates a shallow copy of this object of all simple properties
		/// </summary>
		public static StatusDomain Clone(Tracker.Data.EFDAL.Interfaces.Entity.IStatusDomain item)
		{
			var newItem = new StatusDomain();
			newItem.ID = item.ID;
			newItem.Status = item.Status;
			return newItem;
		}

		#endregion

		#endregion

	}

}
