﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using Tracker.Helper.Mapper;
using Tracker.Helper;
using Tracker.Presenters;
using Tracker.Views;

namespace Tracker
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            //auto mapper
            AutoMapperConfiguration.Configure();

            //castlewindsor
            CastleWindsor.Configure();
            //CastleWindsor.Register<Options>();
            CastleWindsor.Register<ITrackerView, Tracker>();
            CastleWindsor.Register<IOptionView, Options>();
            CastleWindsor.Register<OptionPresenter>();

            CastleWindsor.Register<ITrackerPresenter, TrackerPresenter>();

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            var i = CastleWindsor.Resolve<ITrackerPresenter>().TrackerView;
            var f = (Form)i;
            Application.Run(f);
        }


       
    }
}
